package com.mingdao.sample.web;

import com.google.gson.Gson;
import com.mingdao.sample.service.SampleOcrBaiduService;
import com.tencentcloudapi.common.AbstractModel;
import com.tencentcloudapi.common.JsonResponseModel;
import com.tencentcloudapi.ocr.v20181119.models.GeneralBasicOCRRequest;
import com.tencentcloudapi.ocr.v20181119.models.IDCardOCRRequest;
import com.tencentcloudapi.ocr.v20181119.models.VatInvoiceOCRRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@RestController
@RequestMapping("/")
public class HomeController {
    Gson gson = new Gson();

    @Autowired
    private SampleOcrBaiduService sampleOcrBaiduService;

    @PostMapping(path = "")
    public String ocr(@RequestBody String body, @RequestHeader("X-TC-Action") String action) {
        AbstractModel abstractModel = null;
        switch (action) {
            case "IDCardOCR": {
                IDCardOCRRequest request = gson.fromJson(body, IDCardOCRRequest.class);
                abstractModel = sampleOcrBaiduService.idCardOCR(request.getImageUrl());
                break;
            }
            case "GeneralBasicOCR": {
                GeneralBasicOCRRequest request = gson.fromJson(body, GeneralBasicOCRRequest.class);
                abstractModel = sampleOcrBaiduService.generalBasicOCR(request.getImageUrl());
                break;
            }
            case "VatInvoiceOCR": {
                VatInvoiceOCRRequest request = gson.fromJson(body, VatInvoiceOCRRequest.class);
                abstractModel = sampleOcrBaiduService.vatInvoiceOCR(request.getImageUrl());
                break;
            }
            default:
                break;
        }
        JsonResponseModel jsonResponseModel = new JsonResponseModel();
        jsonResponseModel.response = abstractModel;
        return gson.toJson(jsonResponseModel);
    }

}
